package com.notuvy.net.webcache;

import com.notuvy.file.FileContent;
import org.apache.log4j.Logger;

import java.io.File;

/**
 * The result of a cached query.
 * The underlying result is always a file in the web cache.
 * There are helper methods to also access it as a String or Stream if desired.
 *
 * User: Murali
 * Date: 6/29/12
 * Time: 6:53 AM
 * To change this template use File | Settings | File Templates.
 */
public class CacheResult {

    //------------------------------------------------------------
    //- Class Variables

    protected static final Logger LOG = Logger.getLogger("com.notuvy.net");


    //------------------------------------------------------------
    //- Class Functions


    //------------------------------------------------------------
    //- Instance Variables

    private final File fFile;
    private String fExtractedString = null;


    //------------------------------------------------------------
    //- Constructors

    protected CacheResult(File pFile) {
        fFile = pFile;
    }


    //------------------------------------------------------------
    //- Gettors

    public File getFile() {
        return fFile;
    }


    //------------------------------------------------------------
    //- Settors


    //------------------------------------------------------------
    //- Private/Protected Utility Functions


    //------------------------------------------------------------
    //- Public Interface Functions

    public String getStringContent() {
        if (fExtractedString == null) {
            FileContent fc = new FileContent(getFile());
            fExtractedString = fc.readString();
        }

        return fExtractedString;
    }


    //------------------------------------------------------------
    //- Class Interface Functions


    //------------------------------------------------------------
    //- Inner Classes


    //------------------------------------------------------------
    //- Main


}
